package ssw.mj.codegen;

import ssw.mj.ErrorStrings;

/**
 * MircoJava Jump Label.
 * ====================
 * Forward jumps use labels which are still undefined.
 * Such jump instructions are linked in the code.
 * A fixup is made as soon as the label becomes defined.
 * Backward jumps use labels which are already defined.
 * Such jump instructions are already generated with the definite label address.
 * 
 * @author AW
 */
public class Label {
	private final String
		DEST_UNDEF = ErrorStrings.DEST_UNDEF,
		LAB_DEF    = ErrorStrings.LAB_DEF;

	/**	Is the jump destination already defined? */
	private boolean defined = false;

	/**	Jump destination address or head of unresolved forward jumps. */
	private int adr;
	
	/** Generates code for a jump to this label. */
	public void put () {
		/* TODO: put your own code here */
	}
	
	/**	Defines <code>this</code> label to be at the current pc position */
	public void here () {
		/* TODO: put your own code here */
	}
	
	/** Defines <code>this</code> label to be at the position 
	 *	of <code>dest</code>. */
	public void setTo (Label dest) {
		/* TODO: put your own code here */
	}
}
